<template>
  <div class="outer-list">
    <div class="list">
      <ul>
        <div class="spinner" v-if="status == loadingState.loading">
          <font-awesome-icon
            class="icon"
            :icon="icons.faCircleNotch"
          ></font-awesome-icon>
        </div>
        <div class="error" v-if="status == loadingState.error">
          <font-awesome-icon
            class="icon"
            :icon="icons.faExclamation"
          ></font-awesome-icon>
          <span>Podczas ładowania danych wystąpił błąd</span>
        </div>
        <div v-if="status == loadingState.loaded && length == 0">
          <span>Brak elementów do wyświetlenia</span>
        </div>
        <slot v-if="status == loadingState.loaded"></slot>
      </ul>
    </div>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import {
  faCircleNotch,
  faExclamation,
} from "@fortawesome/free-solid-svg-icons";

import { LoadingState } from "@/interfaces";

@Options({
  props: {
    status: Number,
    length: {
      type: Number,
      default: 1,
    },
  },
  components: {
    FontAwesomeIcon,
  },
})
export default class ListBody extends Vue {
  public status = LoadingState.loaded;
  public length!: number;

  public icons = {
    faCircleNotch,
    faExclamation,
  };

  public loadingState = LoadingState;
}
</script>

<style scoped lang="scss">
@import "@/styles/globals";

.outer-list {
  width: 100%;
  overflow: hidden;
  position: relative;
}

.list {
  display: flex;
  flex-flow: column;
  align-items: center;

  overflow-y: scroll;

  width: calc(100% + 8px);
  max-height: 100%;

  scrollbar-width: thin;

  &::-webkit-scrollbar {
    width: 11px;
  }

  ul {
    display: grid;

    grid-gap: $small_spacing 0;

    width: $max_list_width;
    max-width: calc(100% - 2 *#{$standard_margin});
    padding: $small_spacing 0;
    margin: 0px;

    .spinner {
      .icon {
        @include spinner;
      }
    }
    .error {
      color: $red;
      span {
        padding-left: 10px;
      }
    }
  }
}
</style>
